#pragma once

#include <SimoxUtility/meta/enum/EnumNames.hpp>

namespace armarx::navigation::common
{

    enum class ControllerType
    {
        PlatformGlobalTrajectory,
        PlatformLocalTrajectory
    };

    constexpr const char* PlatformGlobalTrajectoryControllerName = "PlatformGlobalTrajectory";
    constexpr const char* PlatformLocalTrajectoryControllerName = "PlatformLocalTrajectory";

    inline const simox::meta::EnumNames<ControllerType> ControllerTypeNames{
        {ControllerType::PlatformGlobalTrajectory, PlatformGlobalTrajectoryControllerName},
        {ControllerType::PlatformLocalTrajectory, PlatformLocalTrajectoryControllerName}};


} // namespace armarx::navigation::common
