#include "ArVizDrawer.h"

#include <iomanip>
#include <sstream>

#include <ArmarXCore/core/logging/Logging.h>


#include <RobotAPI/components/ArViz/Client/Client.h>
#include <RobotAPI/components/ArViz/Client/Elements.h>
#include <RobotAPI/components/ArViz/Client/Layer.h>
#include <RobotAPI/components/ArViz/Client/elements/Color.h>
#include <RobotAPI/components/ArViz/Client/elements/Mesh.h>
#include <RobotAPI/components/ArViz/Client/elements/PointCloud.h>

namespace armarx::navigation::components::dynamic_scene_provider
{

    ArVizDrawer::ArVizDrawer(armarx::viz::Client& arviz) :
        arviz(arviz)
    {
    }

    ArVizDrawer::~ArVizDrawer()
    {
        // make sure, the Arviz Ice calls are handled.
        // {
        //     std::unique_lock g{layerMtx};
        //     g.lock();
        // }
    }

    inline std::string
    nameWithId(const std::string& name, const int id, const unsigned int idWidth = 6)
    {
        std::stringstream ss;
        ss << name << "_" << std::setw(static_cast<int>(idWidth)) << std::setfill('0') << id;
        return ss.str();
    }

    inline std::string nameWithIds(const std::string& name,
                                   const int id,
                                   const int subId,
                                   const unsigned int idWidth = 6)
    {
        std::stringstream ss;
        ss << name << "_" << std::setw(static_cast<int>(idWidth)) << std::setfill('0') << id << "_"
           << std::setw(static_cast<int>(idWidth)) << std::setfill('0') << subId;
        return ss.str();
    }

    void ArVizDrawer::visualizeFoo()
    {
        auto layer = arviz.layer("my_layer_name");

        // TODO: populate layer, e.g.
        // odomLayer.add(viz::Pose("odom").pose(odomPose.translation() * 1000, odomPose.linear()));
       
        arviz.commit(layer);
    }

}  // namespace armarx::navigation::components::dynamic_scene_provider
